package model

import (
	"gorm.io/plugin/soft_delete"
	"time"
)

// ApprovalTypeGroup 审批类型分组
type ApprovalTypeGroup struct {
	ID            uint64                `gorm:"primaryKey;column:id" json:"id"`          // ID
	DeletedAt     soft_delete.DeletedAt `gorm:"column:deleted_at" json:"deletedAt"`      // 删除时间
	CreatedAt     time.Time             `gorm:"column:created_at" json:"createdAt"`      // 创建时间
	UpdatedAt     time.Time             `gorm:"column:updated_at" json:"updatedAt"`      // 更新时间
	Domain        *string               `gorm:"column:domain" json:"domain"`             // domain
	Title         string                `gorm:"column:title" json:"title"`               // 名称
	ApprovalTypes []*ApprovalType       `gorm:"foreignKey:GroupId" json:"approvalTypes"` //
}

// TableName get sql table name.获取数据库表名
func (m *ApprovalTypeGroup) TableName() string {
	return "approval_type_group"
}

func GetGroupIdByName(title, domain string) (uint64, error) {
	var groupObj *ApprovalTypeGroup
	DB.Model(&ApprovalTypeGroup{}).Where(&ApprovalTypeGroup{Title: title, Domain: &domain}).First(&groupObj)
	if groupObj == nil || groupObj.ID == 0 {
		groupObj = &ApprovalTypeGroup{
			Domain: &domain,
			Title:  title,
		}

		err := DB.Model(&ApprovalTypeGroup{}).Save(&groupObj).Error
		if err != nil {
			return 0, err
		}
	}

	return groupObj.ID, nil
}
